' StartStopVLC_4.vbs v1.00 by Sven Rowoldt
' Starts or stops a soundfile with VLC
' Start the Script ALWAYS with a given soundfile with full path and in quotes like:
'
' C:\Users\abt\Music\StartStopVLC_4.vbs "C:\Users\abt\Music\3 01.m4a"
'
' The script checks if VLC is running by doing an API-call.
' If it is not running, vlc will be started to play the specified soundfile.
' If it is running, it will be termineated.
' If using MidiKey2Key, set the path\soundfile enclosed in DOUBLE QUOTES like ""C:\Users\abt\Music\3 01.m4a""
' and correct these when editing something, because quote-pairs will always be removed (bug).
'
' This script will not work properly, if multiple instances of vlc are running.
'
' Please edit the path to VLC below.
'msgbox (WScript.Arguments.length)
'msgbox (WScript.Arguments(0))
' ============= EDIT HERE: =================================================
vlcPath      = "C:\Program Files (x86)\VideoLAN\VLC\vlc.exe" '             =
' ==========================================================================


' DO NOT CHANGE ANYTHING BELOW THIS LINE (except vlc-command-parameters)!
' =============================================================================================
if WScript.Arguments.length = 0 then
	msgbox ("Please call the script with an full-path soundfile within quotes as argument!" & vbcrlf & vbcrlf & "Example: ...\StartStopVLC_4.vbs ""C:\music files\myfile.mp3""")
	WScript.Quit
end if

Set FSO = CreateObject ("Scripting.FilesystemObject")
if FSO.FileExists(WScript.Arguments(0)) = false then
	msgBox("The soundfile '" & WScript.Arguments(0) & "' was not found.")
	WScript.Quit
end if

Set wshshell = CreateObject("WScript.Shell")
soundFile    = WScript.Arguments(0)
sComputerName = "."
Set objWMIService = GetObject("winmgmts:\\" & sComputerName & "\root\cimv2")
running = false
sQuery = "SELECT * FROM Win32_Process WHERE Name LIKE '%vlc.exe%'"
Set objItems = objWMIService.ExecQuery(sQuery)

For Each objItem In objItems
	if InStr (objItem.Name, "vlc.exe") > 0 then
		running = true
		exit For
	end if
Next

if running then
	wshshell.Run """" & vlcPath & """ vlc://quit", 0, false
else
	wshshell.Run """" & vlcPath & """ --qt-start-minimized --play-and-exit --qt-notification=0 """ & soundFile & """", 0, false
end if

WScript.Quit








